#include "common-cab.h"
#include "common.h"
#include <stdio.h>
#include <stdlib.h>
#include <glib.h>
#include "configio.h"


/* read a line */
char *readl(FILE *f)
{
int ch;
char c[2];
char *s=NULL;

c[1]=0;

ch=fgetc(f);
if ((ch=='\n') || (feof(f))) return(NULL);

while ((ch!='\n') && (!feof(f)))
	{
	c[0]=ch;
	s=strgrow(s,c,1,0);
	ch=fgetc(f);
	}
return(s);
}


jpair *read_config()
{
FILE *f;
char *fn=NULL;
jpair *j=NULL;
char *x=NULL;

fn=strgrow(fn,getenv("HOME"),1,0);
fn=strgrow(fn,"/.cabbar/config",1,0);

f=fopen(fn,"r");
if (f!=NULL)
	{
	while(!feof(f))
		{
		char *l=NULL;
		char *l2=NULL;
		char *key=NULL;
		char *val=NULL;
		char *val2=NULL;
	
		l=readl(f);
		if (l!=NULL) x=index(l,'=');
		if ((x!=NULL) && ((l!=NULL) && (l[0]!='=')))
			{
			l2=g_strdup(l);
			val=g_strdup(strstr(l,"="));
			key=g_strdup(strtok(l2,"="));
			val2=g_strdup(&val[1]);
			j=jpair_add(j, key, val2);
			g_free(val);
			g_free(l2);
			}
		g_free(l);
		}
	fclose(f);
	}

g_free(fn);
return(j);
}


int write_config(jpair *j)
{
FILE *f;
char *fn=NULL;
jpair *p=NULL;

fn=strgrow(fn,getenv("HOME"),1,0);
fn=strgrow(fn,"/.cabbar/config",1,0);

f=fopen(fn,"w");
if (f==NULL)
	{
	g_free(fn);
	return(1);
	}
p=j;

while(p)
	{
	fprintf(f,"%s=%s\n",p->key,p->val);
	p=p->next;
	}

fclose(f);
g_free(fn);
return(0);
}
