#ifndef _EVENTS_H_
#define _EVENTS_H_

#include "common-cab.h"
#include "common.h"
#include "main.h"
#include "mpair.h"

void read_sock(gpointer	data,  gint	source, GdkInputCondition condition);
void login(char *user, char *pass, char *nick);
void tag_unknown(xpt *x);
void do_message(jpair *data);
void do_status(jpair *data);
void do_roster(jpair *data);
void events_init();
void events_free();
void events_got_stream(char *buf);
void send_data(char *s);
void send_hdr();
void send_login(char *user, char *pass, char *nick);
void send_status(StatusType type, char *say, int pri, IconType icon);
void send_roster_add(char *group, char *uname);
void send_roster_del(char *group, char *uname);
void send_roster_get(char *group);
void connect_login(char *uid, char *pass, char *nick);
void logout(gboolean reinit_events, gboolean gtk_alive);

#endif
