#!/usr/bin/perl

@WDAY = ('Sun','Mon','Tue','Wed','Thu','Fri','Sat');
@MONTH = ('January','February','March','April','May','June','July','August','September','October','November','December');

sub httpd
{
	my($server) = $_[0];
	while(1)
	{
		$sock = $server->accept();
		print "Got connection\n";
		exit unless($sock);
		$sock->autoflush(1);
		&sendrecv($sock);
	}
}


sub sendrecv
{
	print "sendrecv\n";
	my($sock) = $_[0];
	my($file) = &http_recv($sock);
	my($extra) = ($file eq "/status")?"Refresh: 15;url=/status":"";
	my($type) = ($file =~ /\.js/)?"application/x-javascript":"text/html";
	&http_send($sock,$extra,$type);

	print "getting '$file'\n";

	&send_file($sock,"frames.html") if($file eq "/");
	&send_file($sock,"lib.js") if($file eq "/lib.js");
	&send_file($sock,"roster.js") if($file eq "/roster.js");
	$sock->print("<BODY ONLOAD='parent.title_push();'></BODY>") if($file eq "/title");
	$sock->print("<BODY ONLOAD='parent.reflow();'></BODY>") if($file eq "/roster");
	&status_looper($sock)	if($file eq "/status");
	if($file eq "/vars.js")
	{
		$sock->print("my_status = 'Online'; my_id = '$user'; my_nick = '$nick'; my_server = '$jserver';");
	}

	$sock->close();
}

sub http_recv
{
	print "processing headers\n";
	$sock = $_[0];
	$req = "";
	$ENV{'REQUEST_METHOD'} = "GET";
	while(1)
	{
		$sock->sysread($data,1024);
		$req .= $data;
		if($req =~ /\r\n\r\n/)
		{
			($type,$uri) = split(" ",$req);
			($file,$ENV{'QUERY_STRING'}) = split(/\?/,$uri);
			return $file;
		}
	}
}

sub http_send
{
	print "sending data\n";
	my($sock,$extra,$type) = @_;
	my(@d) = gmtime();
	$d[5] = ($d[5] > 50)?"19$d[5]":"20$d[5]";
	$type = (length($type) > 0)?$type:"text/html";

	$sock->print(<<EOF);
HTTP/1.0 200 OK
Server: JabberGrabber/0.0
Last-Modified: $WDAY[$d[6]], $d[3] $MONTH[$d[4]] $d[5] $d[2]:$d[1]:$d[0] GMT
Expires: Fri, 10 Oct 1997 10:10:10 GMT
Content-Type: $type
$extra

EOF

}


sub send_file
{
	print "sending file $file\n";
	my($sock,$file) = @_;
	open(FILE,"<$file") || return;
	$sock->print($_) while(<FILE>);
	close(FILE);
}


sub ReadParse
{
#RETURNS        array of form input values
        local($i, $key, $val, %in);

        if($ENV{'REQUEST_METHOD'} eq "GET")
        {
                $in = $ENV{'QUERY_STRING'};
        }
        elsif($ENV{'REQUEST_METHOD'} eq "POST")
        {
                read(STDIN,$in,$ENV{'CONTENT_LENGTH'});
        }

        @in = split(/&/,$in);

        foreach $i (0 .. $#in)
        {
                $in[$i] =~ s/\+/ /g;
                ($key, $val) = split(/=/,$in[$i],2);
                $key =~ s/%(..)/pack("c",hex($1))/ge;
                $val =~ s/%(..)/pack("c",hex($1))/ge;
                $in{$key} .= "\0" if (defined($in{$key}));
                $in{$key} .= $val;
        }

        return %in;
}



