package org.jabber.client;

import java.awt.*;
import java.awt.event.*;

//import javax.swing.*;
import com.sun.java.swing.*;

import org.jabber.*;

public class MainFrame extends JFrame {
	private Channel channel;
	private MessageArea messageArea;

	public MainFrame() {
	super();
	}
	protected MessageArea createMessageArea() {
	return new MessageArea();
	}
	public Channel getChannel() {
	return this.channel;
	}
	//
	// Aggregate objects (lazily initialized)
	//
	public MessageArea getMessageArea() {
	if(messageArea == null) {
	    messageArea = createMessageArea();
	}

	return messageArea;
	}
	public void init() {
	setSize(new Dimension(400, 200));

	getContentPane().add(getMessageArea(), BorderLayout.CENTER);
	}
	public void setChannel(Channel chan) {
	if(this.channel != null) {
	    // Disconnect listeners from current channel
	}

	this.channel = chan;

	if(this.channel != null) {
	    // Connect listeners to new channel
	}
	}
}