package org.jabber.element;

public class Attribute {
	private String name;
	private Object value;
public Attribute(String name) {
	this.name = name;
}
public Attribute(String name, Object value) {
	this.name = name;
	this.value = value;
}
public void accept(ElementVisitor v) {
	v.visit(this);
}
public String getName() {
	return this.name;
}
public Object getValue() {
	return this.value;
}
public void setValue(Object value) {
	this.value = value;
}
}