package org.jabber.element;

/**
 * This type was created in VisualAge.
 */
public class TextElement extends Element {
	private String text;
/**
 * TextElement constructor comment.
 * @param tag java.lang.String
 */
public TextElement(String tagName, String text) {
	super(tagName);
	this.text = text;
}
public void accept(ElementVisitor v) {
	v.visit(this);
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getText() {
	return text;
}
public boolean isEmpty() {
	return false;
}
/**
 * This method was created in VisualAge.
 * @param newValue java.lang.String
 */
public void setText(String newValue) {
	this.text = newValue;
}
}