package org.jabber.packet;

import java.util.*;

public class MessagePacket extends Packet {
	private Vector to = new Vector();
	private String from;
	private String say;
	private Integer priority;
	private String thread;
	private String subject;
	private String ext;
public MessagePacket(String from, String say) {
	this.from = from;
	this.say = say;
}
public void accept(PacketVisitor v) {
	v.visit(this);
}
public void addTo(String newValue) {
	to.addElement(newValue);
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getExt() {
	return ext;
}
public String getFrom() {
	return from;
}
public String getPacketType() {
	return PacketTypes.MESSAGE;
}
/**
 * This method was created in VisualAge.
 * @return int
 */
public Integer getPriority() {
	return priority;
}
public String getSay() {
	return say;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getSubject() {
	return subject;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getThread() {
	return thread;
}
public Enumeration getTo() {
	return to.elements();
}
public void removeTo(String value) {
	to.removeElement(value);
}
/**
 * This method was created in VisualAge.
 * @param newValue java.lang.String
 */
public void setExt(String newValue) {
	this.ext = newValue;
}
protected void setFrom(String from) {
	this.from = from;
}
/**
 * This method was created in VisualAge.
 * @param newValue int
 */
public void setPriority(Integer newValue) {
	this.priority = newValue;
}
protected void setSay(String say) {
	this.say = say;
}
/**
 * This method was created in VisualAge.
 * @param newValue java.lang.String
 */
public void setSubject(String newValue) {
	this.subject = newValue;
}
/**
 * This method was created in VisualAge.
 * @param newValue java.lang.String
 */
public void setThread(String newValue) {
	this.thread = newValue;
}
}