package org.jabber.packet;

import org.jabber.*;

import java.util.*;

public abstract class Packet implements Cloneable {
public Packet() {
}
public abstract void accept(PacketVisitor v);
public Object clone() {
	try {
		return super.clone();
	} catch (CloneNotSupportedException cnse) {
		return null;
	}
}
public void didReceive() {
}
protected abstract String getPacketType();
public boolean isSelfFormatting() {
	return false;
}
public String toString() {
	return getPacketType();
}
public void willSend() {
}
}