package org.jabber.packet.pipeline;

import java.io.*;
import java.util.*;

import org.jabber.packet.*;

public class PacketParser extends FilteredPipeline {
public PacketParser(Pipeline next) {
	super(next);
}
protected ProtocolBuilder createProtocolBuilder() {
	return new ProtocolBuilder();
}
protected ProtocolConsumer createProtocolConsumer() {
	return new ProtocolConsumer();
}
public Packet receive() throws IOException {
/*	RawPacket raw = (RawPacket) super.receive();
	System.out.println(getClass().getName() + ".receive: " + raw);
	ProtocolConsumer prot = createProtocolConsumer();
	return prot.parse(raw);
*/
	return null;
}
public void send(Packet p) throws IOException {
	if (p.isSelfFormatting()) {
		super.send(p);
		return;
	}
	
	// Unparse the packet into this string
	RawPacket raw = createProtocolBuilder().unparse(p);

	if(raw != null) {
		// Send the raw packet downstream.
		super.send(raw);
	}
}
}