package org.jabber.packet.pipeline;

import java.io.*;

import org.jabber.packet.*;

public class PacketPreparer extends FilteredPipeline {
public PacketPreparer(Pipeline next) {
	super(next);
}
public Packet receive() throws IOException {
	Packet p = super.receive();
	if (p != null)
		p.didReceive();
	return p;
}
public void send(Packet p) throws IOException {
	if(p != null) {
		p.willSend();
	}
	super.send(p);
}
}