#########
# MENUS #
#########

menu .popup_group -tearoff 0
menu .popup_user -tearoff 0
menu .popup_nick -tearoff 0

.popup_group add command -label "Send Message" -font "[.popup_group cget -font] bold" \
  -command {
	set a ""; set b ""; set gname [file tail [Tree:getselection .win.f.tree]]
	foreach a $JabberLib(roster,groups,$gname) {set b "$b,$a"}
        set b [string range $b 1 end]
	sendwin .mes_$gname $b "" "" "" ""
	unset a; unset b; unset gname}
.popup_group add command -label "Send URL"
.popup_group add command -label "Send File" -state disabled
.popup_group add separator
.popup_group add command -label "Add New User" -command adduserwin
.popup_group add separator
.popup_group add command -label "Delete User" -state disabled
.popup_group add command -label "Delete Group" -command {zabber:delgroup [file tail [Tree:getselection .win.f.tree]]}
.popup_group add separator
.popup_group add command -label "Preferences"


.popup_user add command -label "Send Message" -font "[.popup_user cget -font] bold" \
  -command {set uname [file tail [Tree:getselection .win.f.tree]]
	    sendwin .mes_$uname "" "" "" ""
	    unset uname}
.popup_user add command -label "Send URL"
.popup_user add command -label "Send File"
.popup_user add separator
.popup_user add command -label "Add New User" -command adduserwin
.popup_user add separator
.popup_user add command -label "Delete User" -command {zabber:deluser [file tail [set a [Tree:getselection .win.f.tree]]] [lindex [file split $a] 1]}
.popup_user add command -label "Delete Group" -state disabled
.popup_user add separator
.popup_user add command -label "Preferences"


.popup_nick add command -label "Send Message" -font "[.popup_user cget -font] bold" \
  -command {set uname [lindex [file split [Tree:getselection .win.f.tree]] 2]
	    set nname [file tail [Tree:getselection .win.f.tree]]
	    sendwin .mes_$uname_$nname $uname $nname "" "" ""
	    unset uname; unset nname}
.popup_nick add command -label "Send URL"
.popup_nick add command -label "Send File"
.popup_nick add separator
.popup_nick add command -label "Add New User" -command adduserwin
.popup_nick add separator
.popup_nick add command -label "Delete User" -state disabled
.popup_nick add command -label "Delete Group" -state disabled
.popup_nick add separator
.popup_nick add command -label "Preferences"
