rename scrollbar new:scrollbar
rename menu new:menu
rename message new:message
rename menubutton new:menubutton
rename button new:button

proc scrollbar {args} { # This is just for scrollbars on unix (linux) systems to seem correct
global tcl_platform

  set a " -width 12"

  if {$tcl_platform(platform)=="unix"} {set args $args$a}
  eval new:scrollbar $args
}

proc menu {args} {      #This is just for fixing the font under unix (linux) systems (no bold)
global tcl_platform

  set a " -font {{MS Sans Serif} 8}"   ;# Font for windows
  set b " -font {{Helvetica} 12}"      ;# Font for unix (linux)

  if {$tcl_platform(platform)=="windows"} {set args $args$a} \
    elseif {$tcl_platform(platform)=="unix"} {set args $args$b}
  eval new:menu $args
}

proc message {args} {      #This is just for fixing the font under unix (linux) systems (no bold)
global tcl_platform

  set a " -font {{MS Sans Serif} 8}"   ;# Font for windows
  set b " -font {{Helvetica} 12}"      ;# Font for unix (linux)

  if {$tcl_platform(platform)=="windows"} {set args $args$a} \
    elseif {$tcl_platform(platform)=="unix"} {set args $args$b}
  eval new:message $args
}

proc menubutton {args} {      #This is just for fixing the font under unix (linux) systems (no bold)
global tcl_platform

  set a " -font {{MS Sans Serif} 8}"   ;# Font for windows
  set b " -font {{Helvetica} 12}"      ;# Font for unix (linux)

  if {$tcl_platform(platform)=="windows"} {set args $args$a} \
    elseif {$tcl_platform(platform)=="unix"} {set args $args$b}
  eval new:menubutton $args
}

proc button {args} {      #This is just for fixing the font under unix (linux) systems (no bold)
global tcl_platform

  set a " -font {{MS Sans Serif} 8}"   ;# Font for windows
  set b " -font {{Helvetica} 12}"      ;# Font for unix (linux)

  if {$tcl_platform(platform)=="windows"} {set args $args$a} \
    elseif {$tcl_platform(platform)=="unix"} {set args $args$b}
  eval new:button $args
}

proc scrolltree {args} {
global jabber

if {$jabber(gui,tree1)==0 && $jabber(gui,tree2)==1} {return}

eval .win.f.tree yview $args
}

proc scrolltree2 {frac1 frac2} {
global jabber

set jabber(gui,tree1) $frac1
set jabber(gui,tree2) $frac2

.win.f.scr23 set $frac1 $frac2
}
