proc drawwindow {} {
global jabber

    ###################
    # CREATING WIDGETS
    ###################
    toplevel .win -class toplevel -menu .win.m
    wm transient .win .
    wm focusmodel .win passive
    wm geometry .win $jabber(win,geom_mainwin)
    wm maxsize .win 1028 752
    wm minsize .win 116 1
    wm overrideredirect .win 0
    wm resizable .win 1 1
    wm deiconify .win
    wm title .win "zABBER - Test Version"

    wm withdraw .
    wm protocol .win WM_DELETE_WINDOW {
	save_geom_mainwin
	zabber:disconnect
	exit
	}

    frame .win.f -borderwidth 1 -height 75 -relief sunken -width 125
    Tree:create .win.f.tree -width 1 -height 1 -yscrollcommand "scrolltree2"
    scrollbar .win.f.scr23 -orient vert -command "scrolltree"
    frame .win.f0 -borderwidth 2 -relief groove 
    message .win.f0.mes24 -aspect 5000 -borderwidth 0 -padx 2 -pady 2 -text Status 
    menubutton .win.f0.men25 \
        -activebackground #ffffff -anchor w -background #ffffff \
        -disabledforeground #ffffff -highlightbackground #ffffff \
        -menu .win.f0.men25.m -pady 0 -relief sunken \
        -text Offline
    menu .win.f0.men25.m -tearoff 0
    .win.f0.men25.m add radiobutton -label Online -value online -variable jabber(status) -command {global JabberLib; if {$JabberLib(sckstats)=="off"} {zabber:connect} else {.win.f0.men25 configure -text Online}; JabberLib:change:status "online" $jabber(msgs,$jabber(condition)) [.win.f0.spin get] $jabber(condition)}
    .win.f0.men25.m add radiobutton -label Privacy -value OFFLINE -variable jabber(status) -command {global JabberLib; if {$JabberLib(sckstats)=="off"} {zabber:connect} else {JabberLib:change:status "offline" $JabberLib(status,say) "" ""; .win.f0.men25 configure -text Privacy}}
    .win.f0.men25.m add radiobutton -label Offline -value offline -variable jabber(status) -command {global JabberLib; if {$JabberLib(sckstats)=="on"} {zabber:disconnect; destroy .adduserwin}}
    message .win.f0.mes26 -borderwidth 0 -padx 5 -pady 2 -text ""
    spinbutton .win.f0.spin -borderwidth 1 -limit {-25 25} -entbackground #ffffff -execute {global JabberLib; JabberLib:change:status "" $JabberLib(status,say) [.win.f0.spin get] ""}

    ###################
    # SETTING VALUES
    ###################
    .win.f0.spin set 10

    
    ###################
    # SETTING MENUS
    ###################
    menu .win.m

    menu .win.m.jabber -tearoff 0
    menu .win.m.roster -tearoff 0
    menu .win.m.jabber.condition -tearoff 0

    .win.m add cascade -label Jabber -underline 0 -menu .win.m.jabber
    .win.m add cascade -label Roster -underline 0 -menu .win.m.roster

    .win.m.jabber add radiobutton -label Online -value online -variable jabber(status) -command {global JabberLib; if {$JabberLib(sckstats)=="off"} {zabber:connect} else {.win.f0.men25 configure -text Online}; JabberLib:change:status "online" $jabber(msgs,$jabber(condition)) [.win.f0.spin get] $jabber(condition)}
    .win.m.jabber add radiobutton -label Privacy -value OFFLINE -variable jabber(status) -command {global JabberLib; if {$JabberLib(sckstats)=="off"} {zabber:connect} else {JabberLib:change:status "offline" $JabberLib(status,say) "" ""; .win.f0.men25 configure -text Privacy}}
    .win.m.jabber add radiobutton -label Offline -value offline -variable jabber(status) -command {global JabberLib; if {$JabberLib(sckstats)=="on"} {zabber:disconnect; destroy .adduserwin}}

    .win.m.jabber add separator
    .win.m.jabber add cascade -label Condition -menu .win.m.jabber.condition
    .win.m.jabber add separator
    .win.m.jabber add command -label "Preferences" -command configwindow
    .win.m.jabber add separator
    .win.m.jabber add command -label "Exit" -command {save_geom_mainwin; zabber:disconnect; exit}

    .win.m.jabber.condition add radiobutton -label "Happy" -value happy -variable jabber(condition) -command {global JabberLib; JabberLib:change:status "" $jabber(msgs,$jabber(condition)) "" "happy"}
    .win.m.jabber.condition add radiobutton -label "Programming" -value programming -variable jabber(condition) -command {global JabberLib; JabberLib:change:status "" $jabber(msgs,$jabber(condition)) "" "programming"}
    .win.m.jabber.condition add radiobutton -label "Playing" -value playing -variable jabber(condition) -command {global JabberLib; JabberLib:change:status "" $jabber(msgs,$jabber(condition)) "" "playing"}
    .win.m.jabber.condition add radiobutton -label "Eating" -value eating -variable jabber(condition) -command {global JabberLib; JabberLib:change:status "" $jabber(msgs,$jabber(condition)) "" "eating"}
    .win.m.jabber.condition add radiobutton -label "Normal" -value normal -variable jabber(condition) -command {global JabberLib; JabberLib:change:status "" $jabber(msgs,$jabber(condition)) "" "normal"}
    .win.m.jabber.condition add radiobutton -label "Away" -value away -variable jabber(condition) -command {global JabberLib; JabberLib:change:status "" $jabber(msgs,$jabber(condition)) "" "away"}
    .win.m.jabber.condition add radiobutton -label "Sad" -value sad -variable jabber(condition) -command {global JabberLib; JabberLib:change:status "" $jabber(msgs,$jabber(condition)) "" "sad"}
    .win.m.jabber.condition add radiobutton -label "Angry" -value angry -variable jabber(condition) -command {global JabberLib; JabberLib:change:status "" $jabber(msgs,$jabber(condition)) "" "angry"}

    .win.m.roster add command -label "Add New User" -state disabled -command adduserwin
    .win.m.roster add separator
    .win.m.roster add command -label "Delete Group" -state disabled -command {zabber:delgroup [file tail [Tree:getselection .win.f.tree]]}
    .win.m.roster add command -label "Delete User" -state disabled -command {zabber:deluser [file tail [set a [Tree:getselection .win.f.tree]]] [lindex [file split $a] 1]}
    .win.m.roster add separator
    .win.m.roster add command -label "Reload Roster" -state disabled -command {
	global JabberLib
	foreach group $JabberLib(roster,groups) {Tree:delitem .win.f.tree "/$group"}
	JabberLib:roster:reget
    }

    menu .win.m.system
    .win.m.system add command -label deneme
    ###################
    # SETTING GEOMETRY
    ###################
    pack .win.f -anchor center -expand 1 -fill both -side top 
    pack .win.f.tree -anchor center -expand 1 -fill both -side left 
    pack .win.f.scr23 -anchor center -expand 0 -fill y -side left 
    pack .win.f0 -anchor center -expand 0 -fill x -side top 
    pack .win.f0.mes24 -anchor center -expand 0 -fill none -side left 
    pack .win.f0.men25 -anchor center -expand 1 -pady 1 -fill x -side left 
    pack .win.f0.mes26 -anchor center -expand 0 -fill none -side left 
    pack .win.f0.spin -anchor center -expand 0 -fill none -pady 1 -side left 
}

proc adduserwin {} {
global JabberLib

    if {[winfo exists .adduserwin]} {
        wm deiconify .adduserwin; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel .adduserwin -class Toplevel
    wm focusmodel .adduserwin passive
    wm geometry .adduserwin 244x133+271+162
    wm minsize .adduserwin 116 100
    wm overrideredirect .adduserwin 0
    wm resizable .adduserwin 1 0
    wm maxsize .adduserwin 1028 133
    wm deiconify .adduserwin
    wm title .adduserwin "Add User"
    frame .adduserwin.f0 -borderwidth 2 -height 1 
    frame .adduserwin.f0.f0 -borderwidth 2 -height 1 
    message .adduserwin.f0.f0.m0 -padx 5 -pady 2 -text "Select Group" -width 138 
    message .adduserwin.f0.f0.m1 -padx 5 -pady 2 -text "User's Loginname\n(name@server)" -width 138 
    frame .adduserwin.f0.f1 -borderwidth 2 -height 1 -width 136 
    combobox .adduserwin.f0.f1.group -width 1 -editable true -value [lindex $JabberLib(roster,groups) 0] -background #ffffff
      foreach a $JabberLib(roster,groups) {.adduserwin.f0.f1.group list insert end $a}
    entry .adduserwin.f0.f1.user -background #ffffff
    frame .adduserwin.f1 -borderwidth 2 -height 1 
    button .adduserwin.f1.okbut -borderwidth 2 -highlightthickness 1 -padx 0 \
        -pady 0 -text OK -width 17 \
        -command {if {[set group [.adduserwin.f0.f1.group get]]!="" && [set user [.adduserwin.f0.f1.user get]]!=""} {
			JabberLib:roster:adduser $group $user
			client:roster:group $group
			client:roster:user $group $user
			destroy .adduserwin }}
    ###################
    # SETTING GEOMETRY
    ###################
    pack .adduserwin.f0 -anchor center -expand 1 -fill both -side top 
    pack .adduserwin.f0.f0 -anchor center -expand 0 -fill y -side left 
    pack .adduserwin.f0.f0.m0 -anchor w -expand 0 -fill none -pady 10 -side top 
    pack .adduserwin.f0.f0.m1 -anchor w -expand 0 -fill none -pady 10 -side top 
    pack .adduserwin.f0.f1 -anchor center -expand 1 -fill both -side left 
    pack .adduserwin.f0.f1.group -anchor center -expand 0 -fill x -padx 3 \
        -pady 10 -side top 
    pack .adduserwin.f0.f1.user -anchor center -expand 0 -fill x -padx 3 \
        -pady 17 -side top 
    pack .adduserwin.f1 -anchor center -expand 1 -fill x -side top
    pack .adduserwin.f1.okbut -anchor center -expand 0 -fill x -padx 3 -side right 
}

proc debugwin {} {
    ###################
    # CREATING WIDGETS
    ###################
    toplevel .debugwin -class Toplevel
    wm focusmodel .debugwin passive
    wm geometry .debugwin 329x201+189+145
    wm maxsize .debugwin 1028 752
    wm minsize .debugwin 116 1
    wm overrideredirect .debugwin 0
    wm resizable .debugwin 1 1
    wm deiconify .debugwin
    wm title .debugwin "Debug Window"
    frame .debugwin.f0 -borderwidth 2 -relief sunken 
    text .debugwin.f0.text -height 1 -relief flat -state disabled -width 1 \
        -yscrollcommand {.debugwin.f0.scroll set} -wrap char
    scrollbar .debugwin.f0.scroll -command {.debugwin.f0.text yview} -orient vert 
    frame .debugwin.f1 -borderwidth 2 -relief groove 
    message .debugwin.f1.mes -aspect 5000 -borderwidth 0 -padx 5 -pady 2 \
        -text Server: 
    entry .debugwin.f1.entry -width 0 

    ###################
    # SETTING BINDINGS
    ###################
    bind .debugwin.f1.entry <Control-KeyRelease-Return> {.debugwin.f1.entry insert insert "\x0A"}
    bind .debugwin.f1.entry <KeyRelease-Return> {set a [.debugwin.f1.entry get]
                                                 .debugwin.f1.entry delete 0 end
                                                 .debugwin.f0.text configure -state normal
                                                 .debugwin.f0.text insert end "\nDebugServer: $a"
                                                 .debugwin.f0.text see end
                                                 .debugwin.f0.text configure -state disabled
                                                 XML:parse $a "JabberLib:parse:main"}

    ###################
    # SETTING GEOMETRY
    ###################
    pack .debugwin.f0 -anchor center -expand 1 -fill both -side top 
    pack .debugwin.f0.text -anchor center -expand 1 -fill both -side left 
    pack .debugwin.f0.scroll -anchor center -expand 0 -fill y -side left 
    pack .debugwin.f1 -anchor center -expand 0 -fill x -side top 
    pack .debugwin.f1.mes -anchor center -expand 0 -fill none -side left 
    pack .debugwin.f1.entry -anchor center -expand 1 -fill x -side left 
}

proc errorwin {base subject message} {
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base 354x166+170+153
    wm maxsize $base 1028 752
    wm minsize $base 116 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "Error"
    frame $base.f0 -borderwidth 2 -height 75 -relief groove -width 125 
    message $base.f0.mes0 -aspect 5000 -borderwidth 0 -padx 5 -pady 2 -text Subject: 
    entry $base.f0.subject -borderwidth 1 -state disabled -width 0 
    frame $base.f1 -borderwidth 2 -relief sunken 
    text $base.f1.text -height 1 -relief flat -state disabled -width 1 \
        -yscrollcommand "$base.f1.scroll set" -wrap word
    scrollbar $base.f1.scroll -command "$base.f1.text yview" -orient vert 
    frame $base.f2 -borderwidth 2 -relief groove 
    button $base.f2.but33 -borderwidth 1 -highlightthickness 0 -padx 0 \
        -pady 0 -text Ok -width 17 -command "destroy $base"
    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.f0 -anchor center -expand 0 -fill x -ipady 2 -side top 
    pack $base.f0.mes0 -anchor center -expand 0 -fill none -side left 
    pack $base.f0.subject -anchor center -expand 1 -fill x -padx 2 -side left 
    pack $base.f1 -anchor center -expand 1 -fill both -side top 
    pack $base.f1.text -anchor center -expand 1 -fill both -side left 
    pack $base.f1.scroll -anchor center -expand 0 -fill y -side left 
    pack $base.f2 -anchor center -expand 0 -fill x -ipadx 2 -ipady 2 -side top 
    pack $base.f2.but33 -anchor center -expand 0 -fill x -padx 3 -side right 
    ###################
    # PUTTING TEXT
    ###################
    $base.f0.subject configure -state normal
    $base.f1.text configure -state normal
    $base.f0.subject insert end $subject
    $base.f1.text insert end $message
    $base.f0.subject configure -state disabled
    $base.f1.text configure -state disabled

}

#
# $stats can be "new" or "next"
#
proc receivewin {from stats} {
global jabber

    set base .meswin_$from

    if {$stats=="new" && [winfo exist $base]!=0} {
	$base.f2.okbut configure -text "Next" -command "receivewin \{$from\} next"
	return
    }

    set abc [lindex $jabber(messages,$from) end]

    set nick [lindex $abc 0]
    set subject [lindex $abc 1]
    set thread [lindex $abc 2]
    set pri [lindex $abc 3]
    set message [lindex $abc 4]

    unset abc

    set jabber(messages,$from) [lreplace $jabber(messages,$from) end end]

    if {[winfo exists $base]==0} {
	###################
	# CREATING WIDGETS
	###################
	toplevel $base -class Toplevel
	wm focusmodel $base passive
	wm geometry $base $jabber(win,geom_receiwin)
	wm maxsize $base 1028 752
	wm minsize $base 116 1
	wm overrideredirect $base 0
	wm resizable $base 1 1
	wm deiconify $base
	wm title $base "Message Received"
	wm protocol $base WM_DELETE_WINDOW "save_geom_receiwin $base; destroy $base"

	frame $base.f0 -borderwidth 2 -height 75 -relief groove -width 125 
	frame $base.f0.f0 -borderwidth 2 
	message $base.f0.f0.mes20 -aspect 5000 -borderwidth 0 -padx 5 -pady 2 -text From: 
	entry $base.f0.f0.from -borderwidth 1 -highlightbackground #c0c0c0 -width 1 
	message $base.f0.f0.mes21 -aspect 5000 -borderwidth 0 -padx 5 -pady 2 -text Nick: 
	entry $base.f0.f0.nick -borderwidth 1 -highlightbackground #c0c0c0 -width 1 
	message $base.f0.f0.mes26 -aspect 5000 -borderwidth 0 -padx 5 -pady 2 -text Thread: 
	entry $base.f0.f0.thread -borderwidth 1 -highlightbackground #c0c0c0 -width 1 
	message $base.f0.f0.mes27 -aspect 5000 -borderwidth 0 -padx 5 -pady 2 -text Pri: 
	spinbutton $base.f0.f0.pri -borderwidth 1

	frame $base.f0.f1 -borderwidth 2 
	message $base.f0.f1.mes20 -aspect 5000 -borderwidth 0 -padx 5 -pady 2 -text Subject: 
	entry $base.f0.f1.subject -borderwidth 1 -width 0 
	frame $base.f1 -borderwidth 2 -relief sunken 
	text $base.f1.text -height 1 -relief flat -width 1 -yscrollcommand "$base.f1.scroll set" 
	scrollbar $base.f1.scroll -command "$base.f1.text yview" -orient vert 
	frame $base.f2 -borderwidth 2 -relief groove 
	button $base.f2.replybut -borderwidth 1 -highlightthickness 0 -padx 0 -pady 0 -text Reply -command "incr jabber(mesnum); sendwin .mes$jabber(mesnum) \{$from\} \{$nick\} \{$thread\} \{$subject\} \{[zabber:replymsg $message $from]\}"
	button $base.f2.forwardbut -borderwidth 1 -highlightthickness 0 -padx 0 -pady 0 -text Forward -command "incr jabber(mesnum); sendwin .mes$jabber(mesnum) {} {} \{$thread\} \{$subject\} \{$message\}"
	button $base.f2.okbut -borderwidth 1 -highlightthickness 0 -padx 0 -pady 0
	###################
	# SETTING GEOMETRY
	###################
	pack $base.f0 -anchor center -expand 0 -fill x -side top 
	pack $base.f0.f0 -anchor center -expand 0 -fill x -side top 
	pack $base.f0.f0.mes20 -anchor center -expand 0 -fill none -side left 
	pack $base.f0.f0.from -anchor center -expand 1 -fill x -side left 
	pack $base.f0.f0.mes21 -anchor center -expand 0 -fill none -side left 
	pack $base.f0.f0.nick -anchor center -expand 1 -fill x -side left 
	pack $base.f0.f0.mes26 -anchor center -expand 0 -fill none -side left 
	pack $base.f0.f0.thread -anchor center -expand 1 -fill x -side left 
	pack $base.f0.f0.mes27 -anchor center -expand 0 -fill none -side left 
	pack $base.f0.f0.pri -anchor center -expand 0 -fill none -side left 
	pack $base.f0.f1 -anchor center -expand 0 -fill x -side top 
	pack $base.f0.f1.mes20 -anchor center -expand 0 -fill none -side left 
	pack $base.f0.f1.subject -anchor center -expand 1 -fill x -side left 
	pack $base.f1 -anchor center -expand 1 -fill both -side top 
	pack $base.f1.text -anchor center -expand 1 -fill both -side left 
	pack $base.f1.scroll -anchor center -expand 0 -fill y -side left 
	pack $base.f2 -anchor center -expand 0 -fill x -side top 
	pack $base.f2.replybut -anchor center -expand 1 -fill x -padx 2 -side left 
	pack $base.f2.forwardbut -anchor center -expand 1 -fill x -padx 2 -side left 
	pack $base.f2.okbut -anchor center -expand 1 -fill x -padx 2 -side left
    }

    ###################
    # PUTTING VALUES
    ###################
    $base.f0.f0.from configure -state normal
    $base.f0.f0.nick configure -state normal
    $base.f0.f0.thread configure -state normal
    $base.f0.f0.pri configure -state normal
    $base.f0.f1.subject configure -state normal
    $base.f1.text configure -state normal

    $base.f0.f0.from delete 0 end
    $base.f0.f0.nick delete 0 end
    $base.f0.f0.thread delete 0 end
    $base.f0.f0.pri set 0
    $base.f0.f1.subject delete 0 end
    $base.f1.text delete 0.0 end

    $base.f0.f0.from insert end $from
    $base.f0.f0.nick insert end $nick
    $base.f0.f0.thread insert end $thread
    $base.f0.f0.pri set $pri
    $base.f0.f1.subject insert end $subject
    $base.f1.text insert end $message

    $base.f0.f0.from configure -state disabled
    $base.f0.f0.nick configure -state disabled
    $base.f0.f0.thread configure -state disabled
    $base.f0.f0.pri configure -state disabled
    $base.f0.f1.subject configure -state disabled
    $base.f1.text configure -state disabled

    if {[llength $jabber(messages,$from)]==0} {
	$base.f2.okbut configure -text "OK" -command "save_geom_receiwin $base; destroy $base; unset jabber(messages,$from)"
    } else {
	$base.f2.okbut configure -text "Next" -command "receivewin \{$from\} next"
    }

}

proc sendwin {base to nick thread subject message} {
global jabber

    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base $jabber(win,geom_sendwin)
    wm maxsize $base 1028 752
    wm minsize $base 116 1
    wm overrideredirect $base 0
    wm resizable $base 1 1
    wm deiconify $base
    wm title $base "Send Message"
    wm protocol $base WM_DELETE_WINDOW "save_geom_sendwin $base; destroy $base"

    frame $base.f0 -borderwidth 2 -height 75 -relief groove -width 125 
    frame $base.f0.f0 -borderwidth 2 
    message $base.f0.f0.01 -aspect 5000 -borderwidth 0 -padx 5 -pady 2 -text To: 
    entry $base.f0.f0.to -borderwidth 1 -highlightbackground #c0c0c0 -width 1 
    message $base.f0.f0.03 -aspect 5000 -borderwidth 0 -padx 5 -pady 2 -text Nick: 
    entry $base.f0.f0.nick -borderwidth 1 -width 1 
    message $base.f0.f0.mes21 -aspect 5000 -borderwidth 0 -padx 5 -pady 2 -text Thread: 
    entry $base.f0.f0.thread -borderwidth 1 -highlightbackground #c0c0c0 -width 1 
    message $base.f0.f0.mes22 -aspect 5000 -borderwidth 0 -padx 5 -pady 2 -text Pri: 
    spinbutton $base.f0.f0.pri -borderwidth 1
    frame $base.f0.f1 -borderwidth 2 
    message $base.f0.f1.01 -aspect 5000 -borderwidth 0 -padx 5 -pady 2 -text Subject: 
    entry $base.f0.f1.subject -borderwidth 1 -width 0 
    frame $base.f1 -borderwidth 2 -relief sunken 
    text $base.f1.text -height 1 -relief flat -width 1 \
        -yscrollcommand "$base.f1.scroll set" 
    scrollbar $base.f1.scroll -command "$base.f1.text yview" -orient vert 
    frame $base.f2 -borderwidth 2 -relief groove 
    button $base.f2.sendbut -borderwidth 1 -highlightthickness 0 -padx 0 \
        -pady 0 -text Send -width 17 -command "zabber:sendmsg $base; save_geom_sendwin $base; destroy $base"

    ###################
    # SETTING GEOMETRY
    ###################
    pack $base.f0 -anchor center -expand 0 -fill x -side top 
    pack $base.f0.f0 -anchor center -expand 0 -fill x -side top 
    pack $base.f0.f0.01 -anchor center -expand 0 -fill none -side left 
    pack $base.f0.f0.to -anchor center -expand 1 -fill x -side left 
    pack $base.f0.f0.03 -anchor center -expand 0 -fill none -side left 
    pack $base.f0.f0.nick -anchor center -expand 1 -fill x -side left 
    pack $base.f0.f0.mes21 -anchor center -expand 0 -fill none -side left 
    pack $base.f0.f0.thread -anchor center -expand 1 -fill x -side left
    pack $base.f0.f0.mes22 -anchor center -expand 0 -fill none -side left 
    pack $base.f0.f0.pri -anchor center -expand 0 -fill none -side left 
    pack $base.f0.f1 -anchor center -expand 0 -fill x -side top 
    pack $base.f0.f1.01 -anchor center -expand 0 -fill none -side left 
    pack $base.f0.f1.subject -anchor center -expand 1 -fill x -side left 
    pack $base.f1 -anchor center -expand 1 -fill both -side top 
    pack $base.f1.text -anchor center -expand 1 -fill both -side left 
    pack $base.f1.scroll -anchor center -expand 0 -fill y -side left 
    pack $base.f2 -anchor center -expand 0 -fill x -ipadx 2 -ipady 2 -side top 
    pack $base.f2.sendbut -anchor center -expand 0 -fill x -padx 3 -side right 

    ###################
    # PUTTING VALUES
    ###################
    $base.f0.f0.to insert end $to
    $base.f0.f0.nick insert end $nick
    $base.f0.f0.thread insert end $thread
    $base.f0.f1.subject insert end $subject
    $base.f1.text insert end $message
}

