#ifndef _CHATBYMSGWIN_H_
#define _CHATBYMSGWIN_H_

#include <gtk/gtk.h>
#include <stdio.h>
#include <glib.h>

#ifdef GNOME
  #include <gnome.h>
#endif

#include "gui.h"
#include "events.h"
#include "main.h"

void chatbymsg_send(GtkWidget *w, chatbymsg_struct *s);
void chatbymsg_newmsg(chatbymsg_struct *s, msg_struct *m);
void free_chatbymsg(chatbymsg_struct *s);
chatbymsg_struct *create_chatbymsg(userstruct *u);
gint chatbymsg_delete_event(GtkWidget *widget, GdkEvent *event, gpointer data);

#endif