
/*
extended functions to jpair.c in the Jabber project (www.jabber.org)
these routines compare strings with strcasecmp, instead of strcmp

also:
 free_ejpair_val() to free the jpair but the keys
 ejpair_replace() to replace a value in a jpair

disq <disq@iname.com>
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "common.h"

jpair *ejpair_get(jpair *p, char *key);
char *ejpair_getval(jpair *p, char *key);
char *ejpair_getvalnew(jpair *p, char *key);
int ejpair_getflag(jpair *p, char *key);
void free_ejpair_val(jpair *p);
jpair  *ejpair_replace(jpair *p, char *key, char *val); /* val must be malloc'd */
