#ifndef _GUI_H_
#define _GUI_H_

#include "common-cab.h"
#include "main.h"


void loginwin_Ok();
void Status_Change(gpointer data);
void statuswin_Ok();
void statuswin_Destroy();
void extstatuswin_Ok();
void ExtStatus_Change(gpointer data);
void ExtStatus_ChangeIcon(gpointer data);
void rostwin_FuncChange(gpointer data);
void rostwin_ok(GtkWidget *w, gpointer data);
gint delete_event(GtkWidget *widget, GdkEvent *event, gpointer data);
void destroy (GtkWidget *widget, gpointer data);
GtkWidget* new_pixmap (gchar *filename[], GdkWindow *window, GdkColor  *background);
void clist_click_column (GtkCList *aclist, gint column, gpointer data);
void ctree_select_unselect(GtkCTree     *ctree, GtkCTreeNode *row, gint column, gpointer data);
void switch_page(GtkNotebook     *notebook, GtkNotebookPage *page, guint page_num, gpointer data);
GtkWidget *create_status_content(gchar *img[],gchar *text);
void draw_transport(imstruct *im);
imstruct *add_transport(userstruct *u, char *uid, StatusType status_type, char *status, IconType icon_type, signed int pri);
void remove_transport(imstruct *im);
userstruct *add_user(groupstruct *r, char *username, StatusType status_type);
void remove_user(userstruct *u);
groupstruct *add_group(char *title);
void remove_group(groupstruct *r);
void popup_menu(GtkWidget *widget,GdkEventButton *event,gpointer data);
void edit_transport(imstruct *im, char *uid, StatusType status_type, char *status, IconType icon_type, signed int pri);
void edit_user(userstruct *u, char *username, StatusType status_type);
void edit_group(groupstruct *r, char *title);
void add_debug();
void check_move_user_if_status(userstruct *u);
imstruct *nick2struc(userstruct *u, char *nick);
userstruct *uname2struc(char *uid);
groupstruct *groupname2struc(char *name);
gint hide_event(GtkWidget *widget, GdkEvent *event, gpointer data);
void ChangeNodePixmaps(GtkWidget *ctree, GtkCTreeNode *node, char **pix_opened, char **pix_closed);
void remove_all_transports(userstruct *u);
void free_msgstruct(msg_struct *m);
void add_icon_to_queue(userstruct *u, IconQueueType typ);
void remove_icon_from_queue(userstruct *u, IconQueueType typ);
void update_icon(userstruct *u);

#endif
