#!/usr/bin/perl

use IO::Socket;
use Net::Jabber;
require "httpd.pl";
require "jabber.pl";

$| = 1;
$port = 10000 + $$;
$peerhost = $ENV{'REMOTE_ADDR'};
$count = 0;
$fail = 0;

%form = &ReadParse();
$user = $form{'user'};
$pass = $form{'pass'};
$nick = $form{'nick'};
$jserver = $form{'server'};
#$user = "u";
#$pass = "p";
#$nick = "asdf";
#$jserver = "localhost";

print "Content-type: text/html\n\n";

if(length($user) > 0 && length($pass) > 0 && length($jserver) > 0)
{

	unless($server = new IO::Socket::INET(Listen => 5, LocalPort => $port, Proto => 'tcp', Timeout => 60))
	{
		print "<H2>FAILED! Unable to init: $!</H2>";
		exit;
	}

	unless(Connect($jserver))
	{
		print "<H2>Failed Jabber Connect to $jserver</H2>";
		exit;
	}

	Process(1);
	SendSimple("login","user",$user,"pass",$pass,"nick",$nick);
	SendRoster("get");
	SendStatus("I'm Online!","online","online");

	print <<EOF;
<HTML><HEAD><TITLE>JabberGrabber</TITLE></HEAD>
<BODY><H2>Your personal JabberGrabber server has been created.</H2>
<P>You may close
this window or continue browsing with it.</P>
<SCRIPT>
window.open('http://$ENV{'SERVER_NAME'}:$port/','new$port','width=150,height=300');
</SCRIPT>
</BODY></HTML>
EOF

	if(fork() == 0)
	{
		close(STDOUT);
		open(LOG,">/tmp/jg.$port");
		select(LOG);
		$| = 1;
		&httpd($server);
	}
	exit;
}

print <<EOF;
<HTML><HEAD><TITLE>JabberGrabber</TITLE></HEAD>
<BODY><H2>Complete form to create your personal web JabberGrabber.</H2>
<FORM METHOD="post">
Username: <INPUT NAME="user"><BR>
Password: <INPUT NAME="pass"><BR>
Nickname: <INPUT NAME="nick" VALUE="Web Login"><BR>
Server: <INPUT NAME="server" VALUE="$ENV{'SERVER_NAME'}"><BR>
<INPUT TYPE="submit" NAME="submit" VALUE="Login">
</FORM>
</BODY></HTML>
EOF

exit;


sub status_looper
{
	print "doing status\n";
	my($sock) = $_[0];
	$count++;
	Process(1);
	print "processed jabber\n";
	local(%form) = &ReadParse();

	$status = ($form{'status'})?$form{'status'}:"Offline";

	$sock->print("<BODY>");

	if($form{'type'} eq "message")
	{
		SendSimple("message","to",$form{'to'},"say",$form{'say'});
	}

	if($form{'type'} eq "status")
	{
		if($form{'kind'} eq "logout")
		{
			# need to do more cleanup here
			exit;
		}
		SendStatus($form{'desc'});
	}

	if($form{'type'} eq "roster")
	{
		SendRoster("add",$form{'group'},$form{'user'});
	}

	Process(1);

	$sendcmds .= "parent.reflow();\n" if($reflow == 1);
	if(length($sendcmds) > 0)
	{
		$sock->print("<SCRIPT>$sendcmds</SCRIPT>");
		$sendcmds = "";
	}

	$sock->print("</BODY>");
}

sub jsescape
{
	my(%h) = @_;
	foreach(keys(%h))
	{
		$h{$_} =~ s/\"/\\\"/g;
		$h{$_} =~ s/\'/\\\'/g;
		$h{$_} =~ s/\r//g;
		$h{$_} =~ s/\n/\\n/g;
	}
	return %h;
}

