#!/usr/bin/perl

$sendcmds = "";
$reflow = 0;
$rosters = 0;

SetCallbacks("connect" => \&connect, "message" => \&message, "status" => \&status, "roster" => \&roster);

sub connect
{
}

sub message
{
	my(%msg) = &jsescape(Simplify(@_));
	$sendcmds .= <<EOF;
parent.imessage("$msg{'from'}","$msg{'nick'}","$msg{'sub'}","$msg{'say'}");
EOF
}

sub status
{
	my(%s) = &jsescape(Simplify(@_));
	$s{'type'} = (length($s{'type'}) > 0)?$s{'type'}:"normal";
	$sendcmds .= <<EOF;
parent.status("$s{'from'}","$s{'nick'}","$s{'say'}","$s{'icon'}","$s{'type'}");
EOF
}

sub roster
{
	my(%tag) = @_;
	my($att,$name,$id);

	foreach(@{$tag{'children'}})
	{
		$att = $_->{'attribs'};
		($name) = &jsescape($att->{'name'});
		($id) = &jsescape($_->{'data'});
		$sendcmds .= <<EOF;
parent.adduser("$name","$id");
EOF
		SendRoster("get",$name) if($rosters == 0); # hack to get ALL groups on init, easier for now
	}

	$reflow = 1;
	$rosters = 1;
}

1;

