var treestr = new String();
var groups = new Array();
var users = new Array();
var sessions = new Array();
var master = new Array();
var commands = new Array();
var current = -1;
var mbgcolor = "white";
var sbgcolor = "#74a5fd";
var mfont = 'Verdana';

function title_push()
{
	var icon = "comp.blue.gif";
	var iconH = 22;
	var iconW = 20;
	icon = printicon(icon,iconH,iconW);
	window.frames["titleFrame"].document.open("text/html");
	window.frames["titleFrame"].document.write(
  '<BODY BGCOLOR="' + mbgcolor + '"><TABLE BORDER="0" WIDTH="100%"><TR><TD WIDTH="100%">'
+ '<FONT SIZE="+2" COLOR="red">' + my_status
+ '</FONT></TD><TD><A HREF="javascript:parent.setup();">' + icon + '</A></TD></TR></TABLE></BODY>');
	window.frames["titleFrame"].document.close();
}

function reflow_push()
{
	window.frames["rosterFrame"].document.open("text/html");
	window.frames["rosterFrame"].document.write(
  '<BODY BGCOLOR="' + mbgcolor + '">'
+ '<TABLE BORDER="0" WIDTH="100%">' + treestr
+ '</TABLE></FONT></BODY>');
	window.frames["rosterFrame"].document.close();
}

function reflow()
{
	treestr = "";
	for(var i = 0; i < groups.length; i++)
	{
		treestr += dogroup(groups[i]);
	}
	treestr += docommands();
	window.setTimeout("reflow_push();",0);
}

function docommands()
{
	var result = new String('<TR><TD><HR></TD></TR>');
	var context = "none";
	if(current >= 0)
	{
		context = master[current].type;
	}
	for(var i = 0; i < commands.length; i++)
	{
		if(commands[i].context == context)
		{
			result +=
  '<TR><TD><A HREF="javascript:parent.'
+ commands[i].call + '(' + current + ');">'
+ printname(commands[i].name) + '</A></TD></TR>';
		}
		if(commands[i].context == "all")
		{
			result +=
  '<TR><TD><A HREF="javascript:parent.'
+ commands[i].call + '();">'
+ printname(commands[i].name) + '</A></TD></TR>';
		}
	}
	return result;
}

function dogroup(g)
{
	var icon = "folder.gif";
	var iconH = 22;
	var iconW = 20;
	var bgcolor = mbgcolor;
	var name = printname(g.name);
	var children = new String();
	var result = new String();
	if(g.show)
	{
		icon = "folder.open.gif";
		iconW = 27;
	}
	if(current == g.guid)
	{
		bgcolor = sbgcolor;
		name = '<B>' + name + '</B>';
	}
	for(var i = 0; i < g.users.length && g.show; i++)
	{
		children += douser(g.users[i]);
	}
	icon = printicon(icon,iconH,iconW);
	result +=
  '<TR><TD BGCOLOR="' + bgcolor + '">'
+ '<A HREF="javascript:parent.refresh(' + g.guid + ');">' + icon
+ name + '</A></TD></TR>' + children;
	return result;
}

function douser(u)
{
	var icon = new String();
	var iconH = 22;
	var iconW = 20;
	var bgcolor = mbgcolor;
	var name = printname(u.name);
	var children = new String();
	var result = new String();
	if(current == u.guid)
	{
		bgcolor = sbgcolor;
		name = '<B>' + name + '</B>';
	}
	for(var i = 0; i < u.sessions.length && u.show && u.sessions[i].online; i++)
	{
		children += dosession(u.sessions[i]);
	}
	result +=
  '<TR><TD BGCOLOR="' + bgcolor + '">&nbsp;&nbsp;&nbsp;&#149;&nbsp;'
+ '<A HREF="javascript:parent.refresh(' + u.guid + ');">' + icon
+ '<SMALL>' + name + '</SMALL></A></TD></TR>' + children;
	return result;
}

function dosession(s)
{
	var result = new String();
	var bgcolor = mbgcolor;
	var name = printname(s.nick);
	if(current == s.guid)
	{
		bgcolor = sbgcolor;
		name = '<B>' + name + '</B>';
	}
	result +=
  '<TR><TD BGCOLOR="' + bgcolor + '">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'
+ '<A HREF="javascript:parent.refresh(' + s.guid + ');">'
+ '<SMALL><TT>' + name + '</TT></SMALL></A></TD></TR>';
	return result;
}

function printicon(name,height,width)
{
	var result = new String();
	result = 
  '<IMG SRC="http://jabber.org/icons/' + name + '" BORDER="0" '
+ 'ALIGN="absbottom" HSPACE="2" VSPACE="0" HEIGHT="' + height
+ '" WIDTH="' + width + '">';
	return result;
}

function printname(name)
{
	var result = new String();
	result = 
  '<FONT FACE="' + mfont + '">'
+ name + '</FONT>';
	return result;
}

function refresh(guid)
{
	if(master[guid].show)
	{
		master[guid].show = true;
	}
	else
	{
		master[guid].show = false;
	}
	master[guid].show = master[guid].show ^ true;
	current = guid;
	reflow();
}

function focus(guid)
{
	var obj = master[guid];
	if(obj.type == "user")
	{
		obj.group.show = true;
	}else{
		obj.user.group.show = true;
		obj.user.show = true;
	}
        parent.refresh(guid);
}

/////////

function getgroup(g_name)
{
	var group = new Array();
	for(var i = 0; i < groups.length; i++)
	{
		if(groups[i].name == g_name)
		{
			return groups[i];
		}
	}
	group.guid = master.length;
	group.name = g_name;
	group.users = new Array();
	group.type = "group";
	groups[groups.length] = group;
	master[master.length] = group;
	return group;
}

function getuser(u_name)
{
	var user = new Array();
	for(var i = 0; i < users.length; i++)
	{
		if(users[i].name == u_name)
		{
			return users[i];
		}
	}
	user.guid = master.length;
	user.name = u_name;
	user.sessions = new Array();
	user.type = "user";
	user.group = new Array(); // initialize to nothing
	users[users.length] = user;
	master[master.length] = user;
	return user;
}

function getsession(u_name, u_nick)
{
	var sess = new Array();
	var user = getuser(u_name);
	for(var i = 0; i < sessions.length; i++)
	{
		if(sessions[i].name == u_name && sessions[i].nick == u_nick)
		{
			return sessions[i];
		}
	}
	sess.guid = master.length;
	sess.name = u_name;
	sess.nick = u_nick;
	sess.type = "session";
	sess.user = user;
	sess.online = true;
	user.sessions[user.sessions.length] = sess;
	sessions[sessions.length] = sess;
	master[master.length] = sess;
	return sess;
}

function adduser(g_name,u_name)
{
	var group = getgroup(g_name);
	var nodup = true;
	for(var i = 0; i < group.users.length; i++)
	{
		if(group.users[i].name == u_name)
		{
			nodup = false;
		}
	}
	if(nodup && u_name.length > 0)
	{
		var user = getuser(u_name);
		group.users[group.users.length] = user;
		user.group = group;
	}
}

function addcommand(f_name, f_call, context)
{
	var command = new Array();
	command.name = f_name;
	command.call = f_call;
	command.context = context;
	commands[commands.length] = command;
}

