package org.jabber;

import java.net.*;

public class ConnectionEvent extends java.util.EventObject {
	private InetAddress endpoint;
	private String reason;
	private Throwable exception;

public ConnectionEvent(Object source) {
	super(source);
}
public ConnectionEvent(Object source, String reason) {
	super(source);
	this.reason = reason;
}
public ConnectionEvent(Object source, Throwable exception) {
	super(source);
	this.exception = exception;
}
public ConnectionEvent(Object source, InetAddress endpoint) {
	super(source);
	this.endpoint = endpoint;
}
public Channel getChannel() {
	return (Channel) getSource();
}
public InetAddress getEndpoint() {
	return this.endpoint;
}
public Throwable getException() {
	return this.exception;
}
public String getReason() {
	return this.reason;
}
}