package org.jabber.client;

import java.awt.*;

//import javax.swing.*;
import com.sun.java.swing.*;

import org.jabber.*;

public class MessageArea extends JPanel implements ConnectionListener {
	private TextArea buffer;
	private Channel channel;

	public MessageArea() {
	add(getBuffer(), BorderLayout.CENTER);
	}
	//
	// Template methods
	//
	protected void activate() {
	getBuffer().setBackground(UIManager.getColor("textInactiveText"));
	}
	//
	// Event sink: ConnectionEvent
	//
	public void attemptingConnection(ConnectionEvent evt) {
	}
	public void channelConnected(ConnectionEvent evt) {
	activate();
	}
	public void channelDisconnected(ConnectionEvent evt) {
	deactivate();
	}
	public void connectFailed(ConnectionEvent evt) {
	}
	protected TextArea createBuffer() {
	return new TextArea();
	}
	protected void deactivate() {
	getBuffer().setBackground(UIManager.getColor("text"));
	}
	public TextArea getBuffer() {
	if(buffer == null) {
	    buffer = createBuffer();
	}

	return buffer;
	}
	public Channel getChannel() {
	return this.channel;
	}
	public void setChannel(Channel chan) {
	if(this.channel != null) {
	    this.channel.removeConnectionListener(this);
	}

	this.channel = chan;

	if(this.channel != null) {
	    this.channel.addConnectionListener(this);

	    if(this.channel.isConnected()) {
		activate();
	    } else {
		deactivate();
	    }
	}
	}
}