package org.jabber.packet;

/**
 * This type was created in VisualAge.
 */
public class LoginPacket extends Packet {
	private String name;
	private String password;
	private String nick;
/**
 * LoginPacket constructor comment.
 */
public LoginPacket(String name, String password) {
	this(name, password, null);
}
public LoginPacket(String name, String password, String nick) {
	this.name = name;
	this.password = password;
	this.nick = nick;
}
/**
 * accept method comment.
 */
public void accept(PacketVisitor v) {
	v.visit(this);
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getName() {
	return name;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getNick() {
	return nick;
}
/**
 * getPacketType method comment.
 */
protected String getPacketType() {
	return null;
}
/**
 * This method was created in VisualAge.
 * @return java.lang.String
 */
public String getPassword() {
	return password;
}
public static LoginPacket prototype() {
	return new LoginPacket(null, null);
}
/**
 * This method was created in VisualAge.
 * @param newValue java.lang.String
 */
public void setName(String newValue) {
	this.name = newValue;
}
/**
 * This method was created in VisualAge.
 * @param newValue java.lang.String
 */
public void setNick(String newValue) {
	this.nick = newValue;
}
/**
 * This method was created in VisualAge.
 * @param newValue java.lang.String
 */
public void setPassword(String newValue) {
	this.password = newValue;
}
}