package org.jabber.packet.pipeline;

import java.io.*;

import org.jabber.packet.*;

public class FilteredPipeline extends Pipeline {
	private Pipeline next = null;
public FilteredPipeline(Pipeline next) {
	this.next = next;
}
public void close() throws IOException {
	getNext().close();
}
protected Pipeline getNext() {
	return next;
}
public Packet receive() throws IOException {
	return getNext().receive();
}
public void send(Packet p) throws IOException {
	getNext().send(p);
}
}