package org.jabber.packet.pipeline.test;

import junit.framework.*;
/**
 * This type was created in VisualAge.
 */
public class AllTests {
public static void main(String[] args) {
	junit.textui.TestRunner.run(suite());
}
public static Test suite() {
	TestSuite suite = new TestSuite();

	suite.addTest(FilteredPipelineTest.suite());
	suite.addTest(InputStreamReceiverTest.suite());
	suite.addTest(OutputStreamSenderTest.suite());
	suite.addTest(PacketPreparerTest.suite());
	suite.addTest(PipelineTailTest.suite());
	suite.addTest(PipeSplitterTest.suite());
	
	return suite;
}
}