#!/usr/bin/wish

set jabber(username) "username"
set jabber(pass) "pass"
set jabber(nick) "nick"
set jabber(server) "127.0.0.1"

set jabber(condition) "normal"
set jabber(status) "offline"
set jabber(priority) "10"

set jabber(mesnum) "0"

source ./JabberLib/jabberlib.tcl

source ./Widget/tree.tcl
source ./Widget/spinbutton.tcl
source ./Widget/combobox.tcl
source ./Widget/notebook.tcl
source other.tcl
source menus.tcl
source procs.tcl
source windows.tcl
source configure.tcl

package require combobox 1.06
catch {namespace import combobox::*}


#################
# 
# zABBER code starts here...
# 

image create photo idisconnect -file "./Pix/offline.ppm"

#image create photo imessage -file "./Pix/message.ppm"
#image create photo ifile -file "./Pix/file.ppm" ;#Not used....

image create photo ihappy -file "./Pix/happy.ppm"
image create photo iprogramming -file "./Pix/program.ppm"
image create photo iplaying -file "./Pix/playing.ppm"
image create photo ieating -file "./Pix/eating.ppm"
image create photo iconnect -file "./Pix/online.ppm"
image create photo iaway -file "./Pix/away.ppm"
image create photo isad -file "./Pix/sad.ppm"
image create photo iangry -file "./Pix/angry.ppm"

loadconfig
drawwindow
debugwin

.win.f.tree bind x <1> {
  set lbl [Tree:labelat %W %x %y]
  Tree:setselection %W $lbl

  set a [llength [file split $lbl]]
    if {$a==3} {
	.win.m.roster entryconfigure 2 -state disabled
	.win.m.roster entryconfigure 3 -state normal} \
    elseif {$a==2} {
	.win.m.roster entryconfigure 2 -state normal
	.win.m.roster entryconfigure 3 -state disabled} \
    else {
	.win.m.roster entryconfigure 2 -state disabled
	.win.m.roster entryconfigure 3 -state disabled}
}

.win.f.tree bind x <3> {
  set lbl [Tree:labelat %W %x %y]
  Tree:setselection %W $lbl
  set x [expr [winfo x .win.f.tree]+%X]     ;#We get x coordinate on the screen
  set y [expr [winfo y .win.f.tree]+%Y]     ;#We get y coordinate on the screen
  set a [llength [file split $lbl]]

  if {$a==2} {tk_popup .popup_group $x $y} \
    elseif {$a==3} {tk_popup .popup_user $x $y} \
    elseif {$a==4} {tk_popup .popup_nick $x $y}

  if {$a==3} {
    .win.m.roster entryconfigure 2 -state disabled
    .win.m.roster entryconfigure 3 -state normal} \
  elseif {$a==2} {
    .win.m.roster entryconfigure 2 -state normal
    .win.m.roster entryconfigure 3 -state disabled} \
  else {
    .win.m.roster entryconfigure 2 -state disabled
    .win.m.roster entryconfigure 3 -state disabled}
}

.win.f.tree bind x <Double-1> {
if {[llength [file split [Tree:getselection .win.f.tree]]]==4} {sendwin .mes$jabber(mesnum) [lindex [file split [Tree:getselection .win.f.tree]] 2] [file tail [Tree:getselection .win.f.tree]] "" "" ""; incr jabber(mesnum)} \
  elseif {[llength [file split [Tree:getselection .win.f.tree]]]==3} {sendwin .mes$jabber(mesnum) [file tail [Tree:getselection .win.f.tree]] "" "" "" ""; incr jabber(mesnum)} \
  else {Tree:open %W  [Tree:labelat %W %x %y]}
}
update

#client:msg:normal from nick subject thread pri message
