#include "common.h"

/* !!! Doesn't work yet */
struct config etc;

int main()
{
  char buf[200];
  int done, count;
  xptpool *xp;
  xpt *xml, *next;

  printf("Starting xpt stream!\n");

  xp = xpt_packet_new();
  do {
    size_t len = fread(buf, 1, sizeof(buf), stdin);
    done = len < sizeof(buf);
    count = 0;
    xpt_packet_data(xp,buf,len);
    xml = xp->packets;
    next = xml;
    while(next != NULL)
    {
	xml = next;
	next = next->next;
        xml->next = NULL;
	printf("Packet---\\\n");
/*	xpt_print(xml,2);*/
/*	jpair_print(xpt2jpair(xml->children));*/
	printf("%s",xpt2str(xml));
	printf("\n---------/\n");
    }
	xp->packets = NULL;
	switch(xp->flag)
	{
		case XPT_POOLFLAG_CLOSE:
			printf("Found end, closing!\n");
			break;
		case XPT_POOLFLAG_ERROR:
		      fprintf(stderr,
            		  "%s at line %d\n",
            		  XML_ErrorString(XML_GetErrorCode(xp->parser)),
            		  XML_GetCurrentLineNumber(xp->parser));
			return 1;
		break;
	}
    
  } while (!done);
  XML_ParserFree(xp->parser);

  printf("\n-------\n");
  return 0;
}

