conn *dispatch(char *p, conn *c, int flag);
void handle_packet(conn *c, xpt *x);

void sig_die();
char *make_tag_quick(char *name, char *value);

void config_init();
void config_help();
void users_initialize(xpt *x);

void transport_deliver(char *from_user, char *from_nick, char *to_user, char *to_nick, xpt *x);

void deliver_message(char *from_user, char *from_nick, char *to_user, char *to_nick, char *subject, char *say, char *thread, char *ext, int priority, char *type);

void status_update(char *user, char *nick, char *to, int status, char *say, char *icon, char *ext, int priority);
void status_manager(int type, char *nick, char *say, char *icon, int priority);
jpair *get_primary();

char *create_packet(char *name, jpair *atts, char *body);

void logger(int level, char *from, char *message);

void forward_packet(char *to, xpt *x);
char *resolve(xpt *xml);
char *new_fork(char *user);

void icq_main();
void AddContact(int uin);
void EventLogin(void* data);
void EventDisconnect(void* data);
void EventMessage(void* data);
void EventChangeStatus(void* data);
void EventSearchResults(void* data);
void EventInfo(void* data);
void EventExtInfo(void* data);
