#include <strings.h>
#include <stdio.h>
#include <unistd.h>
#include <errno.h>
#include "laim_core.h"
extern "C" {
#include "common.h"
struct config etc = {NULL, NULL, NULL, "<j ", "</j>", 0};
}

AIM_session aim;

void handle_test(tag *t, void *null)
{
	printf("Handling tag %s containing %s\n",t->name,t->contents);
}

void main()
{
	Contact *c;
	tap tp = {NULL,&handle_test,0};

	tag_parse(&tp,"<tag>thistest</tag><user>pass word</user>sdf",NULL);

	printf("Starting\n");
	aim.screen_name = strdup("QuartZ2jer");
	aim.password = strdup("Michael");
	printf("Connecting\n");
	aim.init();
	printf("Logging in\n");
	aim.login();
        switch (aim.error_num) {
                case 0x01 :
                        printf("Invalid screen name\n");
                        break;
                case 0x05 :
                        printf("Invalid password\n");
                        break;
                case 0x18 :
                        printf("Too many login attempts. Try again later.\n");
                        break;
                default :
                        printf("Successfully logged in\n");
        }

	aim.patient(false);

	printf("Fetching QuartZ jer contact\n");
	c = contact.find_contact("QuartZ jer");
	printf("Starting main loop.\n");

	while(errno != ENOTCONN)
	{
		sleep(1);
		printf("Loop\n");

		aim.recv_buf();
		if(aim.recv_buffer.length() > 0)
		{
			aim.SNAC_decode();
			printf("NOTICE[%s]\n",aim.notice_str.c_str());

			if(aim.mesg_biff)
			{
				aim.mesg_biff = false;
				printf("MESSAGE[%s]\n",( (contact.updated())->mesg ).c_str() );

				printf("Sending message reply to QuartZ jer\n");
				aim.send_buffer = c->send_IM("This is a test message!");
				aim.send_buf(0x02);
			}
		}
	}
}

